Package org.bgerp.util.sql.pool

# Class ConnectionPool

java.lang.Object
org.bgerp.util.sql.pool.ConnectionPool

public class ConnectionPool extends Object

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `RETURN_FAKE`
  `static final int`
  `RETURN_MASTER`
  `static final int`
  `RETURN_NULL`
  `static final int`
  `RETURN_SLAVE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ConnectionPool(String name, ConfigMap map)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `ConnectionSet`
  `getConnectionSet()`
  `ConnectionSet`
  `getConnectionSet(boolean autoCommit)`
  `DataSource`
  `getDataSource()`
  `final Connection`
  `getDBConnectionFromPool()`
  Возвращает соединение с Master БД из пула.
  `final Connection`
  `getDBSlaveConnectionFromPool()`
  Возвращает соединение с Slave БД из пула.
  `final Connection`
  `getDBSlaveConnectionFromPool(Connection master)`
  Возвращает соединение с Slave БД из пула.
  `String`
  `getDbTrace()`
  `final Connection`
  `getDBTrashConnectionFromPool(String tableName, int retType)`
  Возвращает соединение с мусорной БД если она описана для таблицы в конфиге либо в зависимости от retType.
  `final Connection`
  `getDBTrashOrMasterConnectionFromPool(String tableName)`
  Возвращение соединения к выделенной "мусорной" либо Master-базе (если треш-база не найдена).
  `final Connection`
  `getDBTrashOrSlaveConnectionFromPool(String tableName)`
  Возвращение соединения к выделенной "мусорной" либо Slave-базе
  `final Set<String>`
  `getSlaveBaseId()`
  Возвращает идентификаторы slave баз.
  `final DataSource`
  `getSlaveDataSource()`
  `final Set<String>`
  `getTrashBaseId()`
  Возвращает идентификаторы trash баз.
  `final Connection`
  `getTrashConnectionFromPool(String poolId)`
  Возвращает соединение с trash базой.
  `boolean`
  `isReplicationAvailable(String slaveId)`
  Deprecated.
  `boolean`
  `isReplicationNotBehindMaster(String slaveId)`
  Deprecated.
  `String`
  `poolStatus()`
  `void`
  `setReplicationNotBehindMaster(String slaveId, boolean isNotBehind)`
  Deprecated.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### RETURN_NULL

    public static final int RETURN_NULL
    See Also:
      - Constant Field Values

  - ### RETURN_FAKE

    public static final int RETURN_FAKE
    See Also:
      - Constant Field Values

  - ### RETURN_SLAVE

    public static final int RETURN_SLAVE
    See Also:
      - Constant Field Values

  - ### RETURN_MASTER

    public static final int RETURN_MASTER
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ConnectionPool

    public ConnectionPool(String name, ConfigMap map)

- ## Method Details

  - ### getDataSource

    public DataSource getDataSource()

  - ### getConnectionSet

    public ConnectionSet getConnectionSet()

  - ### getConnectionSet

    public ConnectionSet getConnectionSet(boolean autoCommit)

  - ### close

    public void close()

  - ### getDBConnectionFromPool

    public final Connection getDBConnectionFromPool()
    Возвращает соединение с Master БД из пула.
    Returns:
      соединение с Master БД либо null в случае недоступности.

  - ### getSlaveDataSource

    public final DataSource getSlaveDataSource()

  - ### getDBSlaveConnectionFromPool

    public final Connection getDBSlaveConnectionFromPool()
    Возвращает соединение с Slave БД из пула. Если Slave БД не определены в конфигурации - возвращает из Master пула.
    Returns:

  - ### getDBSlaveConnectionFromPool

    public final Connection getDBSlaveConnectionFromPool(Connection master)
    Возвращает соединение с Slave БД из пула. Если Slave БД не определены в конфигурации - возвращает из Master пула.
    Parameters:
      `masterOnNull` - если false то при отсутсвии slave баз вернет null.
    Returns:

  - ### getDBTrashConnectionFromPool

    public final Connection getDBTrashConnectionFromPool(String tableName, int retType)
    Возвращает соединение с мусорной БД если она описана для таблицы в конфиге либо в зависимости от retType.
    Parameters:
      `tableName` - имя таблицы.
      `retType` - `RETURN_FAKE`, `RETURN_SLAVE` либо `RETURN_MASTER`.
    Returns:
      если не указана конфигурация мусорной БД может быть возвращен коннект к мастер БД, фейковый коннект либо коннект Slave БД.

  - ### getDBTrashOrMasterConnectionFromPool

    public final Connection getDBTrashOrMasterConnectionFromPool(String tableName)
    Возвращение соединения к выделенной "мусорной" либо Master-базе (если треш-база не найдена).
    Parameters:
      `tableName` -
    Returns:

  - ### getDBTrashOrSlaveConnectionFromPool

    public final Connection getDBTrashOrSlaveConnectionFromPool(String tableName)
    Возвращение соединения к выделенной "мусорной" либо Slave-базе
    Parameters:
      `tableName` -
    Returns:

  - ### getSlaveBaseId

    public final Set<String> getSlaveBaseId()
    Возвращает идентификаторы slave баз.
    Returns:

  - ### getTrashBaseId

    public final Set<String> getTrashBaseId()
    Возвращает идентификаторы trash баз.
    Returns:

  - ### getTrashConnectionFromPool

    public final Connection getTrashConnectionFromPool(String poolId)
    Возвращает соединение с trash базой. если неверная база то null со всем вытекающим, так как применяется только при принудительном выборе базы в некоторых специфичных служебных случаях.
    Parameters:
      `poolId` - - ид базы
    Returns:
      коннекшен

  - ### poolStatus

    public String poolStatus()
    Returns:
      status text report for connection pools.

  - ### getDbTrace

    public String getDbTrace()
    Returns:
      pool connections borowing stack traces text report.

  - ### setReplicationNotBehindMaster

    @Deprecated public void setReplicationNotBehindMaster(String slaveId, boolean isNotBehind)
    Deprecated.
    Включение/Отключение флага отставания Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
      `isNotBehind` - true - отставание выключено, false - отставание включено

  - ### isReplicationNotBehindMaster

    @Deprecated public boolean isReplicationNotBehindMaster(String slaveId)
    Deprecated.
    Проверяет есть ли отставание Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
    Returns:

  - ### isReplicationAvailable

    @Deprecated public boolean isReplicationAvailable(String slaveId)
    Deprecated.
    Проверяет доступность Slave базы
    Parameters:
      `slaveId` - идентификатор Slave базы
    Returns:
      true - если доступна, false - если не доступна